<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%@ page import="org.wso2.carbon.governance.ui.notifications.clients.InfoAdminServiceClient" %>
<%@ page import="org.wso2.carbon.governance.ui.notifications.beans.xsd.EventTypeBean" %>
<%@ page import="org.wso2.carbon.governance.ui.notifications.beans.xsd.SubscriptionBean" %>
<%@ page import="org.wso2.carbon.governance.ui.notifications.services.utils.xsd.EventType" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String[] events = null;
    String[] resourceEventNames = null;
    String[] collectionEventNames = null;
    boolean isResource = true;
    boolean canSubscribeOthers = false;
    String username = null;
    try{
        InfoAdminServiceClient client = new InfoAdminServiceClient(cookie, config, session);
        SubscriptionBean subscriptionBean = client.getSubscriptions(request);
        EventTypeBean eventTypeBean = client.getEventTypes(request);
        EventType[] eventTypes = eventTypeBean.getEventTypes();
        events = new String[eventTypes.length];
        resourceEventNames = new String[eventTypes.length];
        collectionEventNames = new String[eventTypes.length];
        for (int i = 0; i < eventTypes.length; i++) {
            if (eventTypes[i] != null) {
                events[i] = eventTypes[i].getId();
                resourceEventNames[i] = eventTypes[i].getResourceEvent();
                collectionEventNames[i] = eventTypes[i].getCollectionEvent();
            }
        }
        if (request.getParameter("path") != null) {
            isResource = client.isResource(request);
        }
        canSubscribeOthers = (subscriptionBean.getUserAccessLevel() > 2);
        username = subscriptionBean.getUserName();
    } catch (Exception e){
        response.setStatus(500);
        %><%=e.getMessage()%><%
        return;
    }
%>
 <fmt:bundle basename="org.wso2.carbon.governance.ui.notifications.i18n.Resources">
<table class="insideTable" cellpadding="0" cellspacing="0">
        <tr>
            <td class="leftCol-small"><fmt:message key="event"/>&nbsp;<span class="required">*</span></td>
            <td valign="top" style="text-align:left;">
                <select id="eventList" onchange="changeVisibility()">
                    <option value="0"><fmt:message key="select"/></option>
<%
    for (int i = 0; i < events.length; i++) {
        if (isResource) {
            if (resourceEventNames[i] != null) {
%>
                    <option value="<%=resourceEventNames[i]%>"><fmt:message key="<%=events[i]%>"/></option>
<%
            }
        } else if (collectionEventNames[i] != null) {
%>
                    <option value="<%=collectionEventNames[i]%>"><fmt:message key="<%=events[i]%>"/></option>
<%
        }
    }
%>
                </select>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="notification.method"/>&nbsp;<span class="required">*</span></td>
            <td>
                <select id="notificationMethodList" disabled="disabled" onchange="changeVisibility()">
                    <option value="0"><fmt:message key="select"/></option>
                    <option value="1"><fmt:message key="email"/></option>
                    <option value="2"><fmt:message key="html.plain.text"/></option>
                    <option value="3"><fmt:message key="soap"/></option>
                    <option value="4"><fmt:message key="username"/></option>
                </select>
            </td>
        </tr>
        <tr id="subscriptionDataInputRecord" style="display:none">
            <td>
                <div id="subscriptionDataEmail" style="display:none">
                   <fmt:message key="enter.email.prompt"/>&nbsp;<span class="required">*</span>
                </div>
                <div id="subscriptionDataHTMLSOAP" style="display:none">
                    <fmt:message key="enter.url.prompt"/>&nbsp;<span class="required">*</span>
                </div>
                <div id="subscriptionDataUserProfile" style="display:none">
<%
    if (canSubscribeOthers) {
%>
                    <input type="hidden" id="subscriptionUserProfile" value="" />
<%
    } else {
%>
                    <input type="hidden" id="subscriptionUserProfile" value="<%=username%>" />
<%
    }
%>
                    <fmt:message key="enter.username.prompt"/>&nbsp;<span class="required">*</span>
                </div>
            </td>
            <td><input type="text" id="subscriptionInput" /></td>
        </tr>
</table>
<% if (request.getParameter("notificationMethod") != null) { %>
<script type="text/javascript">
    document.getElementById('eventList').value = "<%=request.getParameter("event")%>";
    var notificationMethod = "<%=request.getParameter("notificationMethod")%>";
    document.getElementById('subscriptionDataInputRecord').style.display = "";
    if (notificationMethod =="email") {
        document.getElementById('notificationMethodList').value = 1;
        document.getElementById('subscriptionDataEmail').style.display = "";
    } else if (notificationMethod =="username") {
        document.getElementById('notificationMethodList').value = 4;
        document.getElementById('subscriptionDataUserProfile').style.display = "";
    } else if (notificationMethod =="html.plain.text") {
        document.getElementById('notificationMethodList').value = 2;
        document.getElementById('subscriptionDataHTMLSOAP').style.display = "";
    } else if (notificationMethod =="soap") {
        document.getElementById('notificationMethodList').value = 3;
        document.getElementById('subscriptionDataHTMLSOAP').style.display = "";
    }
    changeVisibility();
    document.getElementById('subscriptionInput').value = "<%=request.getParameter("input")%>";
</script>
<% } %>
</fmt:bundle>